"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _react = _interopRequireWildcard(require("react"));

var _numeral = _interopRequireDefault(require("numeral"));

var _lodash = _interopRequireDefault(require("lodash"));

var _decimal = require("decimal.js");

var _classnames = _interopRequireDefault(require("classnames"));

var _CurrencySelector = _interopRequireDefault(require("../CurrencySelector"));

var _cookie = _interopRequireDefault(require("../utils/cookie"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils.default.prefixCls;

function filterAmount(mode, moneySet) {
  if (!moneySet) return;
  var result;

  if (mode === 'currency') {
    result = moneySet && moneySet.amount;
  } else {
    result = moneySet;
  }

  return result;
}

var AmountInput =
/*#__PURE__*/
function (_Component) {
  _inherits(AmountInput, _Component);

  function AmountInput(_props) {
    var _this;

    _classCallCheck(this, AmountInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AmountInput).call(this, _props));

    _this.handleChange = function (e) {
      var thisValue = e.target.value;

      if (thisValue.startsWith('0') && !thisValue.startsWith('0.')) {
        thisValue = thisValue.slice(thisValue.length - 1);
      }

      ; //不能输入大于1e12的值

      if (_lodash.default.toNumber(thisValue) >= 1e12) return;
      _this.status = 'CHANGING';

      _this.setState({
        value: thisValue
      });
    };

    _this.handleParentChange = function (val) {
      var changeType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'both';
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          mode = _this$props.mode;
      var changeValue;

      if (mode === 'currency') {
        changeValue = val;
      } else {
        if (_lodash.default.isObject(val)) {
          changeValue = val.amount;
        } else {
          changeValue = val;
        }
      }

      if (['onChange', 'both'].includes(changeType)) {
        onChange && onChange(changeValue);
      }
    };

    _this.handleCurrencyChange = function (currency) {
      var value = _this.state.value;

      _utils.default.handleCurrencyOperation(currency.code); //cookie中cache操作记录


      _this.setState({
        currentCurrency: currency
      });

      var changedValue = {
        currency: currency.code,
        amount: value
      };

      _this.handleParentChange(changedValue);
    };

    _this.handleFocus = function (e) {
      var value = (0, _numeral.default)(e.target.value).value();
      _this.status = 'FOCUS';

      _this.setState({
        value: value
      });
    };

    _this.handleBlur = function (e) {
      var currentCurrency = _this.state.currentCurrency;
      var value = parseFloat(e.target.value);
      var value1 = null,
          value2 = null; // 截取到小数点后2位(不做四舍五入)
      // value = Math.floor(value * 100) / 100;

      value = new _decimal.Decimal(value).mul(100).floor().div(100).valueOf();

      if (typeof value === 'number' && value < 0) {
        value = 0;
      }

      if (!isNaN(value)) {
        value1 = _utils.default.formatCurrency(value, _this.valueFormat, '');
        value2 = _utils.default.formatCurrency(value, _this.numberformat, '');
      }

      value2 = {
        currency: currentCurrency.code,
        amount: isNaN(parseFloat(value2)) ? undefined : parseFloat(value2)
      };
      _this.status = 'BLUR';

      _this.setState({
        value: value1
      });

      _this.handleParentChange(value2);
    };

    _this.init = function (props) {
      var money = props.value,
          amount = props.amount,
          readOnly = props.readOnly,
          mode = props.mode;
      _this.valueFormat = props.valueFormat;
      var value = filterAmount(mode, money);
      var currentCurrency = mode === 'currency' ? {
        code: money && money.currency
      } : {
        code: 'CNY'
      }; // 显示批准金额

      if (amount && value && 'amount' in props && value !== amount.amount && readOnly) {
        value = _react.default.createElement("span", null, _utils.default.formatCurrency(value, _this.valueFormat, ''), _react.default.createElement("span", {
          className: "org-amount"
        }, _utils.default.formatCurrency(amount.amount, _this.valueFormat, '')));
      } else if (value || value === 0) {
        value = _utils.default.formatCurrency(value, _this.valueFormat, '');
      }

      _this.setState({
        value: value,
        currentCurrency: currentCurrency
      });
    };

    _this.getAllCurrencys = function () {
      var getAllCurrencys = _this.props.getAllCurrencys;

      _this.setState({
        currencyLoading: true
      });

      if (typeof getAllCurrencys === 'function') {
        getAllCurrencys().then(function (data) {
          _this.setState({
            allCurrencys: data,
            currencyLoading: false
          });
        }).catch(function () {
          _this.setState({
            currencyLoading: false
          });
        });
      }
    };

    _this.valueFormat = _props.valueFormat;
    _this.numberformat = _this.valueFormat === '0,0.00' ? '0.00' : '0';
    _this.formatFlag = true;
    _this.status = 'BLUR';
    _this.t = _mkTranslate.default.getLocalNs('MoneyInput', _assertThisInitialized(_this));
    _this.state = {
      value: filterAmount(_props.mode, _props.value),
      latestCurrencys: _cookie.default.get('latestCurrencys') || [],
      allCurrencys: [],
      currentCurrency: {
        code: 'CNY'
      },
      currencyLoading: false
    };
    return _this;
  }

  _createClass(AmountInput, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var prevAmount = prevProps.amount;
      var _this$props2 = this.props,
          onChange = _this$props2.onChange,
          value = _this$props2.value,
          amount = _this$props2.amount;

      if (!_lodash.default.isEqual(prevProps.value, value) || !_lodash.default.isEqual(prevAmount, amount)) {
        if (this.formatFlag) {
          if (this.status === 'BLUR') {
            this.init(this.props);
            this.formatFlag = false;
          }
        } else if (this.status === 'BLUR') {
          this.init(this.props);
        }

        if (typeof onChange === 'function') {
          this.handleParentChange(value);
        }
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var value = this.props.value;

      if (value) {
        this.init(this.props);
        this.formatFlag = false;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var value = this.state.value;
      var _this$props3 = this.props,
          readOnly = _this$props3.readOnly,
          fieldProperties = _this$props3.fieldProperties,
          fieldStyleCategory = _this$props3.fieldStyleCategory,
          currencyVailable = _this$props3.currencyVailable,
          mode = _this$props3.mode;
      var placeholder = fieldProperties.placeholder;
      var _this$state = this.state,
          latestCurrencys = _this$state.latestCurrencys,
          allCurrencys = _this$state.allCurrencys,
          currentCurrency = _this$state.currentCurrency,
          currencyLoading = _this$state.currencyLoading;
      var currencyDisable = !currencyVailable || readOnly;
      var cnyClz = (0, _classnames.default)('currency-dropdown', {
        // 'focus': this.status !== 'BLUR',
        'readonly': readOnly,
        'disabled': currencyDisable
      });
      return _react.default.createElement("div", {
        className: "".concat(prefix, "-money-wrapper")
      }, mode === 'currency' ? _react.default.createElement(_CurrencySelector.default, {
        latestCurrencys: latestCurrencys,
        data: allCurrencys,
        loading: currencyLoading,
        onChange: this.handleCurrencyChange,
        disabled: currencyDisable,
        visibleChange: function visibleChange(visible) {
          if (visible) _this2.getAllCurrencys();
        }
      }, _react.default.createElement("div", {
        className: cnyClz
      }, _react.default.createElement("span", {
        style: {
          marginRight: 4,
          lineHeight: 'normal'
        }
      }, currentCurrency.code), !currencyDisable ? _react.default.createElement(_icon.default, {
        type: "down"
      }) : null)) : null, _react.default.createElement(_input.default, {
        ref: this.props.forwardedRef,
        value: value,
        placeholder: placeholder,
        onChange: this.handleChange,
        onFocus: this.handleFocus,
        onBlur: this.handleBlur,
        disabled: readOnly,
        category: fieldStyleCategory
      }));
    }
  }]);

  return AmountInput;
}(_react.Component);

AmountInput.defaultProps = {
  valueFormat: '0,0.00',
  currencyVailable: false,
  mode: 'currency'
};

var _default = _react.default.forwardRef(function (props, ref) {
  var value = props.value,
      mode = props.mode;
  var convertValue;

  if (value !== undefined) {
    if (_lodash.default.isObject(value)) {
      convertValue = value;
    } else if (_lodash.default.isNumber(value)) {
      if (mode === 'money') {
        convertValue = value;
      } else {
        convertValue = {
          currency: 'CNY',
          amount: value
        };
      }
    }
  } else {
    convertValue = value;
  }

  return _react.default.createElement(AmountInput, _extends({}, props, {
    value: convertValue,
    ref: ref
  }));
});

exports.default = _default;