"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _AuthorizeContext = require("../../context/AuthorizeContext");

var _Authorize = _interopRequireDefault(require("../../Authorize"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var AuthorizeMaster =
/*#__PURE__*/
function (_Component) {
  _inherits(AuthorizeMaster, _Component);

  function AuthorizeMaster(props) {
    var _this;

    _classCallCheck(this, AuthorizeMaster);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AuthorizeMaster).call(this, props));

    _this.setConfigure = function (obj) {
      _this.setState(_objectSpread({}, obj), function () {
        // 每次更新权限配置的时候，也会将存储在authorize中的更新
        _Authorize.default._setAuthorizeMaster(_assertThisInitialized(_this));
      });
    };

    _this.initVersion = function (version) {
      _this.switchVersion(version);
    };

    _this.switchVersion = function (version) {
      _Authorize.default.switchVersion(_this.setConfigure, version);
    };

    _this.addVersion = function (obj) {
      _Authorize.default._addVersion(obj);
    };

    _this.getConfigureByAuthKey = function (authKeyStr) {
      var _a = authKeyStr.split('.'); // _a: ['home', 'createReceipt']


      var _v = _this.state[_a[0]]; // _v: configure['home']

      for (var i = 1; i < _a.length; i++) {
        if (_v) {
          _v = _v[_a[i]];
        }
      }

      return _v;
    };

    _this.state = {};
    return _this;
  }

  _createClass(AuthorizeMaster, [{
    key: "render",
    value: function render() {
      // authKey是判断取哪个配置key
      var children = this.props.children;
      return _react.default.createElement(_AuthorizeContext.AuthorizeContext.Provider, {
        value: {
          configure: this.state,
          setConfigure: this.setConfigure,
          initVersion: this.initVersion,
          switchVersion: this.switchVersion,
          addVersion: this.addVersion,
          getConfigureByAuthKey: this.getConfigureByAuthKey
        }
      }, children);
    }
  }]);

  return AuthorizeMaster;
}(_react.Component);

var _default = AuthorizeMaster;
exports.default = _default;