### FormDish
FormChef中不会直接引入lib中的FormDish，因为FormDish是实际的表单渲染高阶组件，需要配置过后才可以正常使用。
之所以不在代码级别区分H5和web或者其他场景的,主要为如下原因
1. FormDish的设计是脱离视觉层的，具体的视觉层，应该由使用者决定，只要符合FormDish的开发规范，Field都可以在FormDish中使用
2. 代码层不会预先引入不必要的文件，如果提前定义H5和web的组件，那么在具体的业务前端工程中，代码的打包就会出现大量的非必要代码，比如：H5中出现web端的field组件代码，web中出现H5的field组件代码。

### FormChef,FormDish,FormFood,Field的关系
1. FormChef主要是控制表单的内在运行机制（还是包含了少量UI的控制，比如墓碑图，web端的元素布局控制）
2. FormDish负责控制Field,FormFood的入口，保持一致性的逻辑规则，约束使用者对入口参数的过度滥用。
3. Field是具体的某个表单子组件，比如DatePicker,MoneyInput等
4. FormFood是Field的直接父组件（也可以理解卫Field的wrapper组件），WebFormFood就是一种FormFood组件，是business提供给web端使用的。FormFood组件必须通过FormDish生成。也就是说你可以不用WebFormFood,可以自行开发，但必须受到FormDish的约束，根据Field容器的规则开发。

----
> FormFood的可定制设计，一是为了解决H5端和Web端在UI层的不一致，同时也增加实现层的灵活度。

```jsx static
FormDish((<FormFood><Field /></FormFood>)
```
#### FormChef接口说明
|name|说明|其他|
|--|--|--|
|form|formchef传入子组件的表单功能集合||

##### form属性说明

|name|说明|类型|备注|
|--|--|--|--|--|
|initData|初始化表单数据|function||
|cookForm|表单统一生成的函数，根据表单配置信息，标准输入表单个元素|function||
|formInstantiate|表单实例化过程，解析表单配置，生成field对象，公式依赖，数据池等基础数据|function||
|setWatch|定义观察函数，用于触发某个观察值变动后所触发的动作|function||
|setFieldsValue|设置field的值|function||
|getFieldDecorator|定义基础的formChef field|function||
|getFieldError|获取某个field的错误信息|function||
|validateFields|校验表单的有效性|||
|rebuildForm|重构表单|||
|getFieldValue|获取某个field的值|||
|fetchFormData|获取表单数据|||