"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var fieldMaps = {};
var validators = {}; // specialFields，label 需要自定义的组件 或者不需要 label 的组件

var specialFields = [];
var complexFields = [];

function setFieldMaps(maps) {
  fieldMaps = maps;
}

function addSpecialField(fieldTypes) {
  if (fieldTypes && Array.isArray(fieldTypes)) {
    specialFields = specialFields.concat(fieldTypes);
  }
}

function addComplexField(fieldTypes) {
  if (fieldTypes && Array.isArray(fieldTypes)) {
    complexFields = complexFields.concat(fieldTypes);
  }
}

function getSpecialFields() {
  return specialFields;
}

function getComplexFields() {
  return complexFields;
}

function enhanceFormItem(WrapperComponent) {
  return (
    /*#__PURE__*/
    function (_Component) {
      _inherits(FormDish, _Component);

      function FormDish(_props) {
        var _this;

        _classCallCheck(this, FormDish);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(FormDish).call(this, _props));

        _this.generateProps = function () {
          var _this$props = _this.props,
              _this$props$publicPro = _this$props.publicProps,
              publicProps = _this$props$publicPro === void 0 ? {} : _this$props$publicPro,
              _this$props$privatePr = _this$props.privateProps,
              privateProps = _this$props$privatePr === void 0 ? {} : _this$props$privatePr,
              form = _this$props.form,
              field = _this$props.field,
              _this$props$field = _this$props.field,
              identifier = _this$props$field.identifier,
              property = _this$props$field.property,
              fieldStyleCategory = _this$props.fieldStyleCategory,
              restProps = _objectWithoutProperties(_this$props, ["publicProps", "privateProps", "form", "field", "field", "fieldStyleCategory"]); // readOnly逻辑处理，privateProps中的优先级最高
          // 若privateProps中未设置，则取 publicProps.readOnly || property.isFieldReadOnly


          var _ref = privateProps[identifier] || {},
              logicReadOnly = _ref.readOnly,
              restPrivateProps = _objectWithoutProperties(_ref, ["readOnly"]);

          var readOnly = publicProps.readOnly,
              restPublicProps = _objectWithoutProperties(publicProps, ["readOnly"]);

          var isFieldReadOnly = property.isFieldReadOnly;

          var _readOnly;

          if (typeof logicReadOnly === 'boolean') {
            _readOnly = logicReadOnly;
          } else {
            _readOnly = readOnly || isFieldReadOnly;
          }

          var props = _objectSpread({}, restPublicProps, restProps, {
            fieldStyleCategory: fieldStyleCategory
          }, restPrivateProps || {});

          return {
            extraProps: props,
            readOnly: _readOnly
          };
        };

        _this.filterFieldProps = function () {
          // 若需要 field 中的 type, identifier 等作为props，可在此返回
          return _lodash.default.pick(_this.props.field, ['identifier', 'type', 'detailTableFields', 'formCode']);
        };

        _this.generateNode = function () {
          var _this$props2 = _this.props,
              _this$props2$field = _this$props2.field,
              property = _this$props2$field.property,
              identifier = _this$props2$field.identifier,
              field = _this$props2.field,
              _this$props2$form = _this$props2.form,
              getFieldDecorator = _this$props2$form.getFieldDecorator,
              getFieldValue = _this$props2$form.getFieldValue,
              setWatch = _this$props2$form.setWatch,
              form = _this$props2.form,
              validateRule = _this$props2.validateRule,
              isInTable = _this$props2.isInTable;
          var type = _this.props.field.type;

          if (type === 'SharedFieldRefInput') {
            type = property.reference.type;
          }

          var orgField = _this.fieldMap[type];
          var Field = null;

          if (orgField) {
            if (['CityInput', 'DateTimeInput'].includes(type)) {
              Field = orgField[property.selectionModule || 'SINGLE'];
            } else if (['OptionInput'].includes(type)) {
              Field = orgField[property.sourceMode];
            } else if (['ApplicationDetailListInput'].includes(type)) {
              Field = orgField[property.inputMode];
            } else {
              Field = orgField;
            }
          } //不能把所有form的权限下放到field中，会出现field中滥用的表单功能的现象


          var fieldForm = {
            getFieldValue: getFieldValue,
            setWatch: setWatch
          };

          if (!Field) {
            console.error("\u65E0".concat(type, "\u7C7B\u578B\u7684\u7EC4\u4EF6"));
            return null;
          }

          if (['SplitSpace'].includes(type)) {
            return _react.default.createElement(Field, null);
          } else {
            var _this$generateProps = _this.generateProps(),
                extraProps = _this$generateProps.extraProps,
                readOnly = _this$generateProps.readOnly;

            var fieldProps = _this.filterFieldProps();

            var node = getFieldDecorator(identifier, validateRule)(_react.default.createElement(Field, {
              fieldProperties: property,
              fieldProps: fieldProps,
              extraProps: extraProps,
              fieldForm: fieldForm,
              readOnly: readOnly
            }));
            return WrapperComponent ? _react.default.createElement(WrapperComponent, {
              field: field,
              form: form,
              isInTable: isInTable,
              specialFields: specialFields,
              complexFields: complexFields
            }, node || _react.default.createElement("span", null)) : node;
          }
        };

        var _props$fieldMapsPlus = _props.fieldMapsPlus,
            fieldMapsPlus = _props$fieldMapsPlus === void 0 ? {} : _props$fieldMapsPlus;
        _this.fieldMap = _objectSpread({}, fieldMaps, fieldMapsPlus);
        _this.validators = validators;
        return _this;
      } // extraProps


      _createClass(FormDish, [{
        key: "render",
        value: function render() {
          var property = this.props.field.property;
          var isFieldHide = property.isFieldHide;
          return isFieldHide ? null : this.generateNode();
        }
      }]);

      return FormDish;
    }(_react.Component)
  );
}

enhanceFormItem.defaultProps = {};
enhanceFormItem.propTypes = {
  setFieldMap: _propTypes.default.func,
  setValidator: _propTypes.default.func
};
enhanceFormItem.setFieldMaps = setFieldMaps;
enhanceFormItem.addSpecialField = addSpecialField;
enhanceFormItem.addComplexField = addComplexField;
enhanceFormItem.getSpecialFields = getSpecialFields;
enhanceFormItem.getComplexFields = getComplexFields;
var _default = enhanceFormItem;
exports.default = _default;