"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/date-picker/style/css");

var _datePicker = _interopRequireDefault(require("maycur-antd/lib/date-picker"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _moment = _interopRequireDefault(require("moment"));

var _lodash = require("lodash");

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-date-field");
var disabledRules = {
  gtNow: function gtNow(current) {
    return current > (0, _moment.default)().endOf('day');
  },
  ltNow: function ltNow(current) {
    return current < (0, _moment.default)().subtract(1, 'days').endOf('day');
  }
};
var MonthPicker = _datePicker.default.MonthPicker;

var DateField =
/*#__PURE__*/
function (_Component) {
  _inherits(DateField, _Component);

  function DateField(props) {
    var _this;

    _classCallCheck(this, DateField);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DateField).call(this, props));

    _this.onChange = function (date) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          valueFormat = _this$props.valueFormat;

      _this.setState({
        isClear: !date
      }, function () {
        var changedValue = {
          currentTime: valueFormat === 'YYYY-MM' ? date && date.startOf('month').valueOf() || null : date && date.valueOf() || null,
          timeRange: null
        };
        onChange && onChange(changedValue);
      });
    };

    _this.UNSAFE_componentWillReceiveProps = function (nextProps) {
      var value = nextProps.value;

      if (!(0, _lodash.isEqual)(value, _this.props.value)) {
        _this.setDefaultValue(nextProps);
      }
    };

    _this.state = {
      defaultValue: props.value && props.value.currentTime && (0, _moment.default)(props.value.currentTime),
      isClear: false
    };
    _this.setDefaultValue = _this.setDefaultValue.bind(_assertThisInitialized(_this));
    _this.t = _mkTranslate.default.getLocalNs('FormFields', _assertThisInitialized(_this));
    return _this;
  } // afterChange = (changedValue) => {
  //     const { onChange } = this.props;
  //     onChange && onChange({
  //         value: changedValue
  //     });
  // }


  _createClass(DateField, [{
    key: "setDefaultValue",
    value: function setDefaultValue(props) {
      var valueDefault = props.valueDefault,
          shouldShowNow = props.shouldShowNow,
          value = props.value,
          valueFormat = props.valueFormat;
      var singleValue = value && value.currentTime;
      var defaultValue = value && value.currentTime;

      if (singleValue) {
        defaultValue = valueFormat === 'YYYY-MM' ? (0, _moment.default)(singleValue).startOf('month') : (0, _moment.default)(singleValue);
        this.onChange(defaultValue);
      } else if (valueDefault === 'NOW' && shouldShowNow && !this.state.isClear) {
        // 修复日期清空不掉的bug
        defaultValue = valueFormat === 'YYYY-MM' ? (0, _moment.default)().startOf('month') : (0, _moment.default)();
        this.onChange(defaultValue);
      }

      this.setState({
        defaultValue: defaultValue
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props2 = this.props,
          valueDefault = _this$props2.valueDefault,
          value = _this$props2.value,
          shouldShowNow = _this$props2.shouldShowNow;
      var defaultValue = value && value.currentTime; // 新建的费用，且用户选择默认空值

      if (valueDefault === 'NA' && shouldShowNow) {
        defaultValue = null;
        this.onChange(defaultValue);
      } else {
        this.setDefaultValue(this.props);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          _this$props3$valueFor = _this$props3.valueFormat,
          valueFormat = _this$props3$valueFor === void 0 ? 'YYYY-MM-DD' : _this$props3$valueFor,
          fieldProperties = _this$props3.fieldProperties,
          readOnly = _this$props3.readOnly,
          disabledDate = _this$props3.disabledDate,
          fieldStyleCategory = _this$props3.fieldStyleCategory;
      var defaultValue = this.state.defaultValue;
      var placeholder = fieldProperties.placeholder,
          required = fieldProperties.required;
      var showTime = false;
      var dateFormat = valueFormat || 'YYYY-MM-DD';

      if (valueFormat.includes('HH:mm') || valueFormat.includes('A')) {
        showTime = true;

        if (valueFormat.search(/HH:mm$/ig) > 0) {
          showTime = {
            format: 'HH:mm'
          };
        }
      } // let disabledValue = defaultValue && defaultValue.format(dateFormat);


      var Picker = valueFormat === 'YYYY-MM' ? MonthPicker : _datePicker.default;
      return _react.default.createElement("div", {
        className: cmName
      }, _react.default.createElement(Picker, {
        defaultValue: defaultValue,
        value: defaultValue,
        format: dateFormat,
        disabledDate: disabledDate && disabledRules[disabledDate],
        placeholder: readOnly ? this.t('empty') : placeholder,
        showTime: showTime,
        allowClear: !required,
        onChange: this.onChange,
        className: fieldStyleCategory === 'origin' ? "".concat(cmName, "_table-cell") : "".concat(cmName, "_normal"),
        disabled: readOnly
      }));
    }
  }]);

  return DateField;
}(_react.Component);

var _default = DateField;
exports.default = _default;