"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/input-number/style/css");

var _inputNumber = _interopRequireDefault(require("maycur-antd/lib/input-number"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var cnName = "".concat(_utils.default.prefixCls, "-number-field");

var MKNumberInput =
/*#__PURE__*/
function (_Component) {
  _inherits(MKNumberInput, _Component);

  function MKNumberInput(props) {
    var _this;

    _classCallCheck(this, MKNumberInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(MKNumberInput).call(this, props));

    _this.onInputNumberChange = function (value) {
      _this.setState({
        value: value
      });
    };

    _this.onBlur = function (e) {
      var onChange = _this.props.onChange;
      var _value = e.target.value;

      if (typeof onChange === 'function') {
        onChange(_value);
      }
    };

    _this.state = {
      value: props.value
    };
    _this._format = props.valueFormat;
    return _this;
  }

  _createClass(MKNumberInput, [{
    key: "monitorValueFormat",
    value: function monitorValueFormat(value) {
      if (value === "0" || value === "00") {
        return '0';
      } else if (value === '00.00') {
        return '0.00';
      } else {
        var splitvalue = '0';

        for (var i = 0; i < value - 1; i++) {
          splitvalue += '0';
        }

        return '0.' + splitvalue;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          readOnly = _this$props.readOnly,
          fieldStyleCategory = _this$props.fieldStyleCategory,
          fieldProperties = _this$props.fieldProperties,
          value = _this$props.value;
      var placeholder = fieldProperties.placeholder;
      return _react.default.createElement("div", {
        className: cnName
      }, _react.default.createElement(_inputNumber.default, _extends({
        value: value,
        placeholder: placeholder,
        onBlur: this.onBlur,
        onFocus: this.onFocus,
        disabled: readOnly
      }, this.props, {
        category: fieldStyleCategory
      })));
    }
  }]);

  return MKNumberInput;
}(_react.Component);

var _default = MKNumberInput;
exports.default = _default;