"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _DepartmentSelectionModal = _interopRequireDefault(require("../../DepartmentSelectionModal"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var cmName = "".concat(_utils.default.prefixCls, "-staff-field");
var DEPARTMENT_PICKER = {
  SCOPE_ALL: 'ALL',
  SCOPE_DEPARTMENT: 'DEPARTMENT',
  SCOPE_STAFF: 'STAFF',
  DEPARTMENT: 'DEPARTMENT',
  STAFF: 'STAFF',
  SOURCE_LIST: 'DEPARTMENT_PICKER_SOURCE_LIST',
  SEARCH_LIST: 'DEPARTMENT_PICKER_SEARCH_LIST'
};

var StaffField =
/*#__PURE__*/
function (_Component) {
  _inherits(StaffField, _Component);

  function StaffField(props) {
    var _this;

    _classCallCheck(this, StaffField);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(StaffField).call(this, props));

    _this.formatValue = function (value) {
      return value && value.map(function (val) {
        return val && val.userName;
      }).join(' , ');
    };

    _this.switchModal = function () {
      _this.setState(function (_ref) {
        var modalVisible = _ref.modalVisible;
        return {
          modalVisible: !modalVisible
        };
      });
    };

    _this.handleChange = function (selectList) {
      var onChange = _this.props.onChange;
      if (typeof onChange === 'function') onChange(_this.convertFormValue(selectList));

      _this.setState(function (_ref2) {
        var modalVisible = _ref2.modalVisible;
        return {
          modalVisible: !modalVisible
        };
      });
    };

    _this.convertFormValue = function (data) {
      if (data instanceof Array && data.length > 0) {
        return data.map(function (d) {
          return {
            userCode: d.code,
            userName: d.name,
            userEmployeeNo: d.userEmployeeId
          };
        });
      } else {
        return [];
      }
    };

    _this.reverseFormValue = function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      var _value;

      if (!(data instanceof Array)) {
        _value = [data];
      } else {
        _value = data;
      }

      return _value.map(function (d) {
        return {
          code: d ? d.userCode : null,
          name: d ? d.userName : null,
          type: DEPARTMENT_PICKER.SCOPE_STAFF
        };
      });
    };

    _this.state = {
      modalVisible: false
    };
    return _this;
  }

  _createClass(StaffField, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          value = _this$props.value,
          readOnly = _this$props.readOnly,
          _this$props$fieldProp = _this$props.fieldProperties,
          placeholder = _this$props$fieldProp.placeholder,
          optionMode = _this$props$fieldProp.optionMode,
          maxSelectLength = _this$props$fieldProp.maxSelectLength,
          _this$props$extraProp = _this$props.extraProps,
          fieldStyleCategory = _this$props$extraProp.fieldStyleCategory,
          extraClassName = _this$props$extraProp.extraClassName,
          exceptSelf = _this$props$extraProp.exceptSelf,
          userCode = _this$props.personalInfo.userCode,
          fetchStaff = _this$props.fetchStaff,
          searchStaff = _this$props.searchStaff,
          fetchUserGroup = _this$props.fetchUserGroup;
      var displayValue = this.formatValue(value);
      var modalVisible = this.state.modalVisible;
      var modalProps = {
        visible: modalVisible,
        modalCallBack: this.handleChange,
        onCancel: this.switchModal
      };

      var _value = this.reverseFormValue(value);

      var pickerProps = {
        selectList: _value,
        scope: DEPARTMENT_PICKER.SCOPE_STAFF,
        maxSelectLength: optionMode === 'SINGLE' ? 1 : maxSelectLength,
        fetch: function fetch(code, config) {
          return fetchStaff({
            code: code,
            userCode: userCode,
            exceptSelf: exceptSelf
          }, config);
        },
        search: function search(code, config) {
          return searchStaff({
            code: code,
            userCode: userCode,
            exceptSelf: exceptSelf
          }, config);
        },
        fetchUserGroup: fetchUserGroup
      };
      return _react.default.createElement("div", {
        className: "".concat(cmName, "-select ").concat(extraClassName)
      }, _react.default.createElement("div", {
        onClick: this.switchModal
      }, _react.default.createElement(_input.default, {
        value: displayValue,
        placeholder: placeholder,
        onChange: function onChange() {},
        disabled: readOnly,
        category: fieldStyleCategory
      }), _react.default.createElement(_icon.default, {
        type: 'down',
        className: 'select-down',
        style: fieldStyleCategory === 'origin' ? {
          right: 12
        } : null
      })), _react.default.createElement(_DepartmentSelectionModal.default, {
        modalProps: modalProps,
        pickerProps: pickerProps
      }));
    }
  }]);

  return StaffField;
}(_react.Component);

StaffField.propTypes = {
  fetchStaff: _propTypes.default.func,
  searchStaff: _propTypes.default.func,
  fetchUserGroup: _propTypes.default.func
};
StaffField.defaultProps = {
  disabled: false
};
var _default = StaffField;
exports.default = _default;