"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _OptionInputList = _interopRequireDefault(require("../OptionInputList"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var prefix = _utils.default.prefixCls;

function OptionInputPicker(props) {
  var value = props.value,
      placeholder = props.placeholder,
      showBizCode = props.showBizCode,
      fieldStyleCategory = props.fieldStyleCategory,
      readOnly = props.readOnly,
      legalEntity = props.legalEntity,
      afterChange = props.afterChange;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isDropDown = _useState2[0],
      setIsDropDown = _useState2[1];

  var _useState3 = (0, _react.useState)(),
      _useState4 = _slicedToArray(_useState3, 2),
      legalEntityAuthzs = _useState4[0],
      setLegalEntityAuthzs = _useState4[1];

  var divRef = (0, _react.useRef)(null);
  var hideDropDown = (0, _react.useCallback)(function () {
    if (readOnly) {
      return;
    }

    ;
    setIsDropDown(false);
  }, [readOnly]);
  var showDropDown = (0, _react.useCallback)(function () {
    if (readOnly) {
      return;
    }

    setIsDropDown(true);
  }, [readOnly]);
  var arrowClass = (0, _react.useMemo)(function () {
    return showDropDown ? 'up' : '';
  }, [showDropDown]); // 公司抬头变化时，如果当前选项组的值不满足抬头的权限，要将其清空

  (0, _react.useEffect)(function () {
    var code = legalEntity && legalEntity.code || null;

    if (code && legalEntityAuthzs && legalEntityAuthzs.length) {
      if (legalEntityAuthzs.every(function (_ref) {
        var authzCode = _ref.authzCode;
        return authzCode !== code;
      })) {
        if (typeof afterChange === 'function') {
          afterChange({
            value: undefined
          });
        }
      }
    }
  }, [legalEntity, legalEntityAuthzs, afterChange]);
  return _react.default.createElement("div", {
    ref: divRef
  }, _react.default.createElement(_rcTrigger.default, {
    action: ['click'],
    popupVisible: isDropDown,
    popupAlign: {
      points: ['tl', 'bl'],
      offset: [0, -60]
    },
    popupClassName: "".concat(prefix, "-option-input"),
    popupStyle: {
      maxWidth: divRef && divRef.current ? divRef.current.clientWidth : 400
    },
    popup: _react.default.createElement(_OptionInputList.default, _extends({}, props, {
      legalEntityAuthzs: legalEntityAuthzs,
      onSetLegalEntityAuthz: setLegalEntityAuthzs,
      showDropDown: isDropDown,
      hideDropDown: hideDropDown
    }))
  }, _react.default.createElement("div", {
    className: "".concat(prefix, "-option-input-display-value ").concat(fieldStyleCategory === 'origin' ? "".concat(prefix, "-option-input-table-cell") : null),
    onClick: showDropDown
  }, value && value.name ? _react.default.createElement("div", null, value.name, showBizCode && value.bizCode ? "(".concat(value.bizCode, ")") : '') : _react.default.createElement("div", {
    className: "placeholder"
  }, placeholder), _react.default.createElement("span", {
    className: "ant-select-arrow ".concat(arrowClass),
    unselectable: "on"
  }))));
}

var _default = OptionInputPicker;
exports.default = _default;