"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _AuthorizeContext = require("../../context/AuthorizeContext");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Disable_ClassName = 'auth-disable';

var Authorize =
/*#__PURE__*/
function (_Component) {
  _inherits(Authorize, _Component);

  function Authorize(props) {
    var _this;

    _classCallCheck(this, Authorize);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Authorize).call(this, props));

    _this.classnames = function (c1, c2) {
      if (c1) {
        return "".concat(c1, " ").concat(c2);
      } else {
        return c2;
      }
    };

    _this.getConfigureByAuthKey = function (configure, authKeyStr) {
      var _a = authKeyStr.split('.'); // _a: ['home', 'createReceipt']


      var _v = configure[_a[0]]; // _v: configure['home']

      for (var i = 1; i < _a.length; i++) {
        if (_v) {
          _v = _v[_a[i]];
        }
      }

      return _v;
    };

    _this.clonedNode = function (children, otherProps, _config) {
      if (_config && _config.disable) {
        // 展示但是置灰
        return _react.default.Children.map(children, function (child) {
          return _react.default.createElement(_react.default.Fragment, null, _react.default.isValidElement(child) ? _react.default.cloneElement(child, _objectSpread({}, otherProps, {
            onClick: function onClick(e) {
              e.stopPropagation();
              return false;
            },
            className: _this.classnames(child.props.className, Disable_ClassName)
          })) : null);
        });
      } else {
        return _react.default.Children.map(children, function (child) {
          return _react.default.isValidElement(child) ? _react.default.cloneElement(child, otherProps) : null;
        });
      }
    };

    _this.renderByConfigure = function (configure) {
      var _this$props = _this.props,
          children = _this$props.children,
          authKey = _this$props.authKey,
          otherProps = _objectWithoutProperties(_this$props, ["children", "authKey"]);

      var _defaultHide = configure._defaultHide;

      var _config = _this.getConfigureByAuthKey(configure, authKey);

      if (_defaultHide) {
        if (_config && _config.show) {
          // 是否展示
          return _this.clonedNode(children, otherProps, _config);
        } else {
          return null;
        }
      } else {
        // 默认展示的话：通过hide这个字段来判断是否隐藏
        if (_config && _config.hide) {
          return null;
        } else {
          return _this.clonedNode(children, otherProps, _config);
        }
      }
    };

    _this.state = {};
    return _this;
  }

  _createClass(Authorize, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      // authKey是判断取哪个配置key
      var configure = this.props.configure;
      return configure ? this.renderByConfigure(configure) : _react.default.createElement(_AuthorizeContext.AuthorizeContext.Consumer, null, function (_ref) {
        var _ref$configure = _ref.configure,
            configure = _ref$configure === void 0 ? {} : _ref$configure;
        return _this2.renderByConfigure(configure);
      });
    }
  }]);

  return Authorize;
}(_react.Component);

var _default = Authorize;
exports.default = _default;