"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _EditableTableContext = require("./EditableTableContext");

var _FormChef = _interopRequireDefault(require("../FormChef"));

var _ev = _interopRequireDefault(require("../utils/ev"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var EditableRow = _react.default.forwardRef(function (props, ref) {
  var formValue = props.formValue,
      form = props.form,
      formFields = props.formFields,
      updateRowForms = props.updateRowForms,
      FormDish = props.FormDish,
      FormBuild = props.FormBuild,
      formChange = props.formChange,
      formState = props.formState,
      privateProps = props.privateProps,
      restProps = _objectWithoutProperties(props, ["formValue", "form", "formFields", "updateRowForms", "FormDish", "FormBuild", "formChange", "formState", "privateProps"]);

  var formInstantiate = form.formInstantiate,
      initData = form.initData;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      formReady = _useState2[0],
      setFormReady = _useState2[1];

  (0, _react.useEffect)(function () {
    if (typeof ref === 'function') ref({
      props: props
    });
    updateRowForm();
    return function () {
      return updateRowForm(true);
    }; // 删除行时销毁该行 form
  }, []);
  (0, _react.useEffect)(function () {
    formInit(formFields);
  }, [formFields]);

  var updateRowForm = function updateRowForm(isDestroy) {
    var rowForm = isDestroy ? undefined : form;
    updateRowForms(_defineProperty({}, "".concat(props['data-row-key']), rowForm));
  };

  var formInit =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee() {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return formInstantiate(formFields);

            case 2:
              initData(formValue);
              setFormReady(true);

            case 4:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function formInit() {
      return _ref.apply(this, arguments);
    };
  }();

  return formReady && _react.default.createElement(_EditableTableContext.EditableContext.Provider, {
    value: {
      form: form
    }
  }, _react.default.createElement("tr", restProps));
});

var _default = (0, _FormChef.default)({
  isValueMap: true,
  extra: {
    api: {// TODO 传入方法
      // fetchExternalOptionData: baseService.fetchExternalOptionData 
    },
    emitter: _ev.default,
    isInTable: true
  },
  cookerOption: {
    validateMessages: {
      required: function required() {
        return '该项是必填项';
      },
      string: {
        max: function max(name, maxLength) {
          return "\u6700\u591A\u8F93\u5165".concat(maxLength, "\u4E2A\u5B57");
        }
      }
    }
  }
})(EditableRow);

exports.default = _default;