"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/table/style/css");

var _table = _interopRequireDefault(require("maycur-antd/lib/table"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _EditableCell = _interopRequireDefault(require("./EditableCell"));

var _EditableFormRow = _interopRequireDefault(require("./EditableFormRow"));

var _lodash = _interopRequireDefault(require("lodash"));

var _TableInput = _interopRequireDefault(require("./TableInput.less"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var calTotalWidth = function calTotalWidth() {
  var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var width = 0;

  if (columns instanceof Array && columns.length > 0) {
    columns.forEach(function (col) {
      width = width + col.width;
    });
  }

  return width;
};

var EditableTable =
/*#__PURE__*/
function (_Component) {
  _inherits(EditableTable, _Component);

  function EditableTable(props) {
    var _this;

    _classCallCheck(this, EditableTable);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(EditableTable).call(this, props));

    _this.updateRowForms = function (form) {
      _this.rowForms = _objectSpread({}, _this.rowForms, form);
    };

    _this.setFieldsValue = function (rowKey, key, value) {
      if (_this.rowForms && _this.rowForms[rowKey]) {
        _this.rowForms[rowKey].setFieldsValue(_defineProperty({}, key, value));
      }
    };

    _this.tableValidation = function () {
      var validRowForms = _lodash.default.filter(_lodash.default.values(_this.rowForms), function (form) {
        return form;
      });

      var validations = _lodash.default.map(validRowForms, function (form) {
        return new Promise(function (resolve, reject) {
          form.validateFields(function (err, values) {
            if (!err) {
              resolve(true);
            } else {
              reject();
            }
          });
        });
      });

      return Promise.all(validations);
    };

    _this.handleRowChange = function (rowData, orgRowData) {
      var row = _objectSpread({}, orgRowData, rowData);

      var _this$props = _this.props,
          rowKey = _this$props.rowKey,
          onChange = _this$props.onChange;

      var newData = _toConsumableArray(_this.props.value);

      var index = newData.findIndex(function (item) {
        return row[rowKey] === item[rowKey];
      });
      newData.splice(index, 1, row);
      onChange(newData);
    };

    _this.onRow = function (rowData, index) {
      var _this$props2 = _this.props,
          formFields = _this$props2.columns,
          privateProps = _this$props2.privateProps; // 传给formchef

      var _privateProps = {};

      if (privateProps) {
        for (var key in privateProps) {
          _privateProps[key] = _objectSpread({}, privateProps[key], {
            selectionIndex: index
          });
        }
      }

      return {
        formFields: formFields,
        index: index,
        formValue: rowData,
        updateRowForms: _this.updateRowForms,
        privateProps: _privateProps,
        formChange: function formChange(formData) {
          return _this.handleRowChange(formData, rowData);
        }
      };
    };

    _this.rowForms = {};
    return _this;
  }

  _createClass(EditableTable, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          dataSource = _this$props3.value,
          _columns = _this$props3.columns,
          privateProps = _this$props3.privateProps,
          restProps = _objectWithoutProperties(_this$props3, ["value", "columns", "privateProps"]);

      var components = {
        body: {
          row: _EditableFormRow.default,
          cell: _EditableCell.default
        }
      };

      var columns = _columns.map(function (col) {
        if (!col.editable) {
          return col;
        }

        return _objectSpread({}, col, {
          onCell: function onCell(record, rowIndex) {
            var _privateProps = {};

            if (privateProps) {
              for (var _key in privateProps) {
                _privateProps[_key] = _objectSpread({}, privateProps[_key], {
                  selectionIndex: rowIndex,
                  dataRowKey: record.code
                });
              }
            }

            return {
              record: record,
              handleRowChange: _this2.handleRowChange,
              field: col,
              editable: col.editable,
              privateProps: _privateProps // 传给组件本身

            };
          }
        });
      });

      return _react.default.createElement(_table.default, _extends({
        dataSource: dataSource,
        columns: columns
      }, restProps, {
        components: components,
        rowClassName: _TableInput.default.tableInputRow,
        onRow: this.onRow,
        scroll: {
          x: dataSource && dataSource.length > 0 ? calTotalWidth(columns) : true
        }
      }));
    }
  }]);

  return EditableTable;
}(_react.Component);

EditableTable.defaultProps = {
  pagination: false,
  rowKey: 'code',
  value: [],
  bordered: false
};
EditableTable.propTypes = {
  onRow: _propTypes.default.func,
  dataSource: _propTypes.default.array
};
var _default = EditableTable;
exports.default = _default;