"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

var _react = _interopRequireWildcard(require("react"));

var _reactOnclickoutside = _interopRequireDefault(require("react-onclickoutside"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _cache = _interopRequireDefault(require("../../utils/cache"));

var _mkTranslate = _interopRequireDefault(require("../../utils//mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Group = _radio.default.Group,
    RadioButton = _radio.default.Button;
var Search = _input.default.Search;
var hotCityCodes = _utils.default.hotCity;
var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-city-field-list");
var localstoarge = _cache.default.localStore;
/* 获取每刻城市信息 by code */

function getPlaceDataByCodes(codes) {
  var placesHashMap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var places = [];

  if (_lodash.default.isArray(codes)) {
    _lodash.default.each(codes, function (code) {
      if (code) {
        places.push(placesHashMap[code]);
      }
    });
  } else if (codes) {
    places.push(placesHashMap[codes]);
  }

  return places;
}
/* 获取每刻城市简称 by code */


function getSimpleCityName(code) {
  var placesHashMap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var locationName = '';

  if (code) {
    var lastStrikethroughIndex = code.lastIndexOf('-'),
        placeCode = code.substr(lastStrikethroughIndex + 1);
    var place = placesHashMap[placeCode];

    if (place) {
      locationName = place.name;
    }
  }

  return locationName;
}

var CityList =
/*#__PURE__*/
function (_Component) {
  _inherits(CityList, _Component);

  function CityList(_props) {
    var _this;

    _classCallCheck(this, CityList);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CityList).call(this, _props));

    _this.formatPlaces = function (props) {
      var places = [];
      var type = props.type,
          placesHashMap = props.placesHashMap;

      if (type === 'bank') {
        var bankPlaces = props.bankPlaces;
        places = bankPlaces;
      } else {
        var expensePlaces = props.expensePlaces;
        places = expensePlaces;
      }

      if (places && places.length) {
        _this.setState({
          places: places,
          cityData: places[0].children,
          hotCity: getPlaceDataByCodes(hotCityCodes, placesHashMap),
          latestUseCity: getPlaceDataByCodes(localstoarge.getItem('latestUseCityCodes'), placesHashMap) || []
        });
      }
    };

    _this.handleClickOutside = function (evt) {
      _this.hideDropDown();
    };

    _this.hideDropDown = function () {
      var hideDropDown = _this.props.hideDropDown;

      _this.setState({
        searchValue: ''
      }, function () {
        if (typeof hideDropDown === 'function') {
          hideDropDown();
        }
      });
    };

    _this.expandNextLevelLocation = function (data, index) {
      var _this$state = _this.state,
          selectedCity = _this$state.selectedCity,
          places = _this$state.places;
      var onChange = _this.props.onChange;

      if (index) {
        selectedCity.length = index - 1;
      }

      selectedCity.push(data.code);

      if (!data.children) {
        if (typeof onChange === 'function') {
          onChange({
            location: data.fullCode || selectedCity.join('-'),
            cityPair: null
          });
        }

        _this.setCityToLatestUse(data.code);

        _this.setState({
          cityData: places[0].children,
          selectedCity: ['domestic'],
          cityTab: 'domestic'
        });

        _this.hideDropDown();
      } else {
        _this.setState({
          cityData: data.children,
          selectedCity: selectedCity
        });
      }
    };

    _this.setCityToLatestUse = function (code) {
      var _this$props = _this.props,
          hideFrequent = _this$props.hideFrequent,
          placesHashMap = _this$props.placesHashMap;
      if (hideFrequent) return;
      var selectedIndex,
          latestUseCityCodes = localstoarge.getItem('latestUseCityCodes') || [];
      selectedIndex = _lodash.default.indexOf(latestUseCityCodes, code);

      if (selectedIndex !== -1) {
        latestUseCityCodes.splice(selectedIndex, 1);
      }

      latestUseCityCodes.unshift(code); // 最多保存8个最近使用的城市

      if (latestUseCityCodes.length > 8) {
        latestUseCityCodes.length = 8;
      }

      localstoarge.setItem('latestUseCityCodes', latestUseCityCodes);

      _this.setState({
        latestUseCity: getPlaceDataByCodes(latestUseCityCodes, placesHashMap)
      });
    };

    _this.handleCategoryChange = function (e) {
      var value = e.target.value;
      var places = _this.state.places;
      var cityData = places[0].children,
          selectedCity = ['domestic'];

      if (value === 'abroad') {
        cityData = places[1].children;
        selectedCity = ['abroad'];
      }

      _this.setState({
        cityData: cityData,
        selectedCity: selectedCity,
        cityTab: value
      });
    };

    _this.searchCity = function (searchValue) {
      _this.setState({
        searchValue: searchValue
      });

      var placesHashMap = _this.props.placesHashMap;

      var leafNodes = _lodash.default.filter(placesHashMap, {
        isLeaf: true
      });

      if (searchValue) {
        var searchList = [];

        _lodash.default.each(leafNodes, function (area) {
          if (area.fuzzy.toLowerCase().indexOf(searchValue) !== -1) {
            searchList.push(area);
          }
        });

        _this.setState({
          searchList: searchList
        });
      }
    };

    _this.state = {
      places: [],
      cityData: [],
      selectedCity: ['domestic'],
      hotCity: [],
      latestUseCity: [],
      searchValue: '',
      cityTab: 'domestic'
    };
    _this.t = _mkTranslate.default.getLocalNs('FormFields', _assertThisInitialized(_this));
    return _this;
  }

  _createClass(CityList, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.formatPlaces(this.props);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var type = nextProps.type;

      if (type === 'bank') {
        if (this.props.bankPlaces !== nextProps.bankPlaces) {
          this.formatPlaces(nextProps);
        }
      } else {
        if (this.props.expensePlaces !== nextProps.expensePlaces) {
          this.formatPlaces(nextProps);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          hideFrequent = _this$props2.hideFrequent,
          hideHot = _this$props2.hideHot,
          type = _this$props2.type,
          showDropDown = _this$props2.showDropDown,
          value = _this$props2.value,
          readOnly = _this$props2.readOnly,
          fieldProperties = _this$props2.fieldProperties,
          placesHashMap = _this$props2.placesHashMap;
      var placeholder = fieldProperties.placeholder;
      var _this$state2 = this.state,
          hotCity = _this$state2.hotCity,
          latestUseCity = _this$state2.latestUseCity,
          cityData = _this$state2.cityData,
          selectedCity = _this$state2.selectedCity,
          searchValue = _this$state2.searchValue,
          searchList = _this$state2.searchList;
      var singleValue = value && value.location;
      var cityName = getSimpleCityName(singleValue, placesHashMap) || '';
      var showDropDownClass = showDropDown ? 'in' : '';
      var t = this.t;
      console.log('hotCity===', hotCity);
      return _react.default.createElement("div", {
        className: "dropdown ".concat(showDropDownClass),
        ref: function ref(_ref) {
          _this2.dropdownRef = _ref;
        }
      }, _react.default.createElement("div", {
        className: "".concat(cmName, "-display-value-clone")
      }, singleValue ? _react.default.createElement("div", null, cityName) : _react.default.createElement("div", {
        className: "placeholder"
      }, readOnly ? t('empty') : placeholder)), _react.default.createElement("div", {
        className: "".concat(cmName, "-wrap")
      }, _react.default.createElement("div", {
        className: "search"
      }, _react.default.createElement(Search, {
        placeholder: t('searchKeywords'),
        onSearch: this.searchCity
      })), searchValue ? _react.default.createElement("div", {
        className: "search-pane"
      }, _react.default.createElement("ul", {
        className: cmName
      }, searchList && searchList.map(function (city, index) {
        return _react.default.createElement("li", {
          key: index,
          className: "".concat(cmName, "-item"),
          onClick: function onClick() {
            _this2.expandNextLevelLocation(city);
          }
        }, _react.default.createElement("div", null, _react.default.createElement("h4", {
          className: "".concat(cmName, "-item_name")
        }, city.name), _react.default.createElement("p", {
          className: "".concat(cmName, "-item_desc")
        }, city.fullName)), _react.default.createElement("div", {
          className: "flex-1"
        }), city.children && _react.default.createElement("span", {
          className: "fm fm-angle-right"
        }));
      }))) : _react.default.createElement("div", {
        className: "city-pane"
      }, hideFrequent ? null : _react.default.createElement("div", {
        className: "hot-city-pane"
      }, _react.default.createElement("div", {
        className: "sub-title"
      }, t('cityField.recentlyUsed')), _react.default.createElement("div", {
        className: "hot-city-list"
      }, latestUseCity && latestUseCity.map(function (city, index) {
        return _react.default.createElement(_button.default, {
          key: index,
          onClick: function onClick(e) {
            e.stopPropagation();

            _this2.expandNextLevelLocation(city);
          }
        }, city.name);
      }))), hideHot ? null : _react.default.createElement("div", {
        className: "hot-city-pane"
      }, _react.default.createElement("div", {
        className: "sub-title"
      }, t('cityField.hotCity')), _react.default.createElement("div", {
        className: "hot-city-list"
      }, hotCity && hotCity.map(function (city, index) {
        return _react.default.createElement(_button.default, {
          key: index,
          onClick: function onClick() {
            _this2.expandNextLevelLocation(city);
          }
        }, city.name);
      }))), _react.default.createElement("div", {
        className: "nav"
      }, type === 'bank' ? null : _react.default.createElement(Group, {
        onChange: this.handleCategoryChange,
        defaultValue: "domestic",
        value: this.state.cityTab,
        buttonStyle: "solid"
      }, _react.default.createElement(RadioButton, {
        value: "domestic"
      }, t('cityField.china')), _react.default.createElement(RadioButton, {
        value: "abroad"
      }, t('cityField.international'))), _react.default.createElement("div", {
        className: "crumb"
      }, selectedCity.map(function (cityCode, index) {
        var city = getPlaceDataByCodes(cityCode, placesHashMap);

        if (city && city.length === 1) {
          return _react.default.createElement("span", {
            className: "crumb-item",
            key: cityCode,
            onClick: function onClick() {
              _this2.expandNextLevelLocation(city[0], index + 1);
            }
          }, city[0].name);
        } else {
          return null;
        }
      }))), _react.default.createElement("ul", {
        className: cmName
      }, cityData && cityData.map(function (city, index) {
        return _react.default.createElement("li", {
          key: index,
          className: "".concat(cmName, "-item"),
          onClick: function onClick() {
            _this2.expandNextLevelLocation(city);
          }
        }, _react.default.createElement("span", null, city.name), _react.default.createElement("div", {
          className: "flex-1"
        }), city.children && _react.default.createElement("span", {
          className: "fm fm-angle-right"
        }));
      }))), " "));
    }
  }]);

  return CityList;
}(_react.Component);

CityList.defaultProps = {
  placesHashMap: {}
};

var _default = (0, _reactOnclickoutside.default)(CityList);

exports.default = _default;