"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var TextArea = _input.default.TextArea;
var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-textarea-field");

var TextAreaField =
/*#__PURE__*/
function (_Component) {
  _inherits(TextAreaField, _Component);

  function TextAreaField(props) {
    var _this;

    _classCallCheck(this, TextAreaField);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TextAreaField).call(this, props));

    _this.onChange = function (e) {
      var _value = e.target.value;

      _this.setState({
        value: _value
      });
    };

    _this.onBlur = function () {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          onBlur = _this$props.onBlur;
      var value = _this.state.value;

      if (onChange && typeof onChange === 'function') {
        onChange(value);
      }

      if (typeof onBlur === 'function') {
        onBlur();
      }
    };

    _this.state = {
      value: props.value
    };
    _this.t = _mkTranslate.default.getLocalNs('FormFields', _assertThisInitialized(_this));
    return _this;
  }

  _createClass(TextAreaField, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.state.value) {
        this.setState({
          value: nextProps.value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          fieldProperties = _this$props2.fieldProperties,
          readOnly = _this$props2.readOnly,
          fieldStyleCategory = _this$props2.fieldStyleCategory,
          autosize = _this$props2.autosize;
      var value = this.state.value;
      var placeholder = fieldProperties.placeholder,
          maxLength = fieldProperties.maxLength;
      var displayPlaceholder = !value && readOnly ? this.t('empty') : placeholder; // 数据互联映射过来的值可能是数字，会导致校验出错

      var displayValue = value && value + '' || '';
      return _react.default.createElement("div", {
        className: cmName
      }, _react.default.createElement(TextArea, {
        autoFocus: this.props.autoFocus,
        ref: this.props.forwardedRef,
        onChange: this.onChange,
        onBlur: this.onBlur,
        placeholder: displayPlaceholder,
        value: displayValue,
        autosize: autosize,
        category: fieldStyleCategory,
        disabled: readOnly
      }), !readOnly && _react.default.createElement("div", {
        className: "count"
      }, _react.default.createElement("span", null, value && value.length || 0, "/", _react.default.createElement("span", {
        className: "total-count"
      }, maxLength))));
    }
  }]);

  return TextAreaField;
}(_react.Component);

TextAreaField.defaultProps = {
  autosize: {
    minRows: 1,
    maxRows: 5
  }
};
var _default = TextAreaField;
exports.default = _default;