"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var FilterStateBarItem =
/*#__PURE__*/
function (_Component) {
  _inherits(FilterStateBarItem, _Component);

  function FilterStateBarItem(props) {
    var _this;

    _classCallCheck(this, FilterStateBarItem);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FilterStateBarItem).call(this, props));

    _this.getFilterContentName = function () {
      var _this$props$filter = _this.props.filter,
          value = _this$props$filter.value,
          filterColumn = _this$props$filter.filterColumn;
      var filterName = '';

      if (filterColumn && !(0, _lodash.isEmpty)(value)) {
        var filterOption = filterColumn.filterOption;
        var filterPlainText = [];

        if (filterColumn.filters) {
          (0, _lodash.forEach)(filterColumn.filters, function (item) {
            if (value.includes(item.value)) {
              filterPlainText.push(item.text);
            }
          });
        }

        if (filterOption) {
          switch (filterOption.type) {
            case 'dateRange':
              filterName = (0, _moment.default)(value[0]).format('YYYY/MM/DD') + ' ~ ' + (0, _moment.default)(value[1]).format('YYYY/MM/DD');

              _this.setState({
                name: filterName
              });

              break;

            case 'checkbox':
              if (Array.isArray(value) && value.length > 0 && _typeof(value[0]) === 'object') {
                filterName = value.map(function (item) {
                  return item.text;
                }).join(',');

                _this.setState({
                  name: filterName
                });
              } else {
                filterName = _this.limitLen(filterPlainText.join(','));

                if (!filterName && typeof filterColumn.filtersSync === 'function') {
                  var _map = {};
                  filterColumn.filtersSync().then(function (res) {
                    if (Array.isArray(res)) {
                      res.forEach(function (item) {
                        _map[item.value] = item.text;
                      });
                      filterName = value.map(function (item) {
                        return _map[item] || item;
                      }).join(',');

                      _this.setState({
                        name: filterName
                      });
                    }
                  });
                } else if (filterName) {
                  _this.setState({
                    name: filterName
                  });
                }
              }

              break;

            case 'search':
              filterName = filterPlainText.length > 0 ? filterPlainText[0] : value;

              _this.setState({
                name: filterName
              });

              break;

            case 'department':
              filterName = filterColumn.selectedList instanceof Array ? filterColumn.selectedList.join(',') : filterColumn.selectedList;

              if (!filterName && Array.isArray(value) && value.length > 0) {
                filterName = value.map(function (item) {
                  return item.name;
                }).join(',');
              }

              _this.setState({
                name: filterName
              });

              break;

            case 'budgetment':
              filterName = filterColumn.selectedList instanceof Array ? filterColumn.selectedList.join(',') : filterColumn.selectedList;

              _this.setState({
                name: filterName
              });

              break;

            case 'budgetSubject':
              filterName = filterColumn.selectedList instanceof Array ? filterColumn.selectedList.join(',') : filterColumn.selectedList;

              _this.setState({
                name: filterName
              });

              break;

            default:
              _this.setState({
                name: value
              });

              break;
          }
        } else if (filterColumn.filters && !filterColumn.filterMultiple) {
          var filterData = (0, _lodash.find)(filterColumn.filters, {
            value: value[0]
          });
          filterName = filterData ? filterData.text : filterName;

          _this.setState({
            name: filterName
          });
        }
      }
    };

    _this.limitLen = function (str) {
      var len = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 12;
      var result = '';

      if ((0, _lodash.isString)(str)) {
        if (str.length > len) {
          result = str.substr(0, len) + '...';
        } else {
          result = str;
        }
      } else {
        result = str;
      }

      return result;
    };

    _this.state = {
      name: ''
    };
    return _this;
  }

  _createClass(FilterStateBarItem, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var filter = this.props.filter;
      this.getFilterContentName(filter);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(preProps) {
      if (!(0, _lodash.isEqual)(preProps.filter, this.props.filter)) {
        this.getFilterContentName(this.props.filter);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          filter = _this$props.filter,
          remove = _this$props.remove;
      var name = this.state.name;
      return _react.default.createElement("div", {
        className: 'filter',
        key: filter.key
      }, _react.default.createElement("span", {
        className: 'filter-label'
      }, filter.label, ":"), _react.default.createElement("span", null, name), _react.default.createElement("span", {
        className: 'filter-close fm fm-cross',
        onClick: function onClick(e) {
          remove(filter);
        }
      }));
    }
  }]);

  return FilterStateBarItem;
}(_react.Component);

var _default = FilterStateBarItem;
exports.default = _default;