"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _reactOnclickoutside = _interopRequireDefault(require("react-onclickoutside"));

var _Loader = _interopRequireDefault(require("../../Loader"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var prefix = _utils.default.prefixCls;
var Search = _input.default.Search;

function OptionInputList(props) {
  var label = props.label,
      showDropDown = props.showDropDown,
      value = props.value,
      placeholder = props.placeholder,
      showBizCode = props.showBizCode,
      search = props.search,
      fetchTreeDetail = props.fetchTreeDetail,
      fetchTree = props.fetchTree,
      dataSource = props.dataSource,
      legalEntity = props.legalEntity,
      afterChange = props.afterChange,
      hideDropDown = props.hideDropDown,
      sourceMode = props.sourceMode,
      privateProps = props.privateProps,
      setWatch = props.setWatch,
      legalEntityAuthzs = props.legalEntityAuthzs,
      onSetLegalEntityAuthz = props.onSetLegalEntityAuthz;

  var _useState = (0, _react.useState)({}),
      _useState2 = _slicedToArray(_useState, 2),
      data = _useState2[0],
      setData = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = _slicedToArray(_useState3, 2),
      crumbs = _useState4[0],
      setCrumbs = _useState4[1];

  var _useState5 = (0, _react.useState)({}),
      _useState6 = _slicedToArray(_useState5, 2),
      originalData = _useState6[0],
      setOriginalData = _useState6[1];

  var _useState7 = (0, _react.useState)([]),
      _useState8 = _slicedToArray(_useState7, 2),
      searchList = _useState8[0],
      setSearchList = _useState8[1];

  var _useState9 = (0, _react.useState)(false),
      _useState10 = _slicedToArray(_useState9, 2),
      loading = _useState10[0],
      setLoading = _useState10[1];

  var transRef = (0, _react.useRef)();
  transRef.current = _mkTranslate.default.noop();
  var hide = (0, _react.useCallback)(function () {
    if (typeof hideDropDown === 'function') {
      hideDropDown();
    }
  }, [hideDropDown]);

  OptionInputList.handleClickOutside = function () {
    hide();
  }; // 创建一个保存公司抬头code的“盒子”


  var legalEntityRef = (0, _react.useRef)(legalEntity ? legalEntity.code : null);
  var showDropDownClass = (0, _react.useMemo)(function () {
    return showDropDown ? 'in' : '';
  }, [showDropDown]);
  var details = (0, _react.useMemo)(function () {
    return data.details && _lodash.default.filter(data.details, {
      enabled: true
    }) || [];
  }, [data]);
  var filterDetail = (0, _react.useCallback)(function (data) {
    return data.filter(function (d) {
      return d.deleted === false && d.enabled === true;
    });
  }, []);
  var legalEntityAuthzsChange = (0, _react.useCallback)(function (legalEntityAuthzs) {
    onSetLegalEntityAuthz(legalEntityAuthzs);
  }, [onSetLegalEntityAuthz]);
  var handleSelect = (0, _react.useCallback)(function (detail) {
    legalEntityAuthzsChange(detail.legalEntityAuthzs);

    if (typeof afterChange === 'function') {
      if (detail.code) {
        afterChange({
          value: {
            code: detail.code,
            name: detail.name,
            extraProperty: detail.extraProperty,
            bizCode: detail.bizCode
          }
        });
      }

      setCrumbs([]);
      setData(originalData);
      setSearchList([]);

      if (typeof hideDropDown === 'function' && detail.code) {
        hideDropDown();
      }
    }
  }, [afterChange, originalData, hideDropDown, legalEntityAuthzsChange]);
  var fetchSearchList = (0, _react.useCallback)(function (keyword) {
    if (typeof search === 'function') {
      setLoading(true);
      search({
        cipherKeyword: keyword,
        keyword: keyword,
        limit: 50,
        referenceDataCode: dataSource,
        legalEntityCode: legalEntityRef.current
      }).then(function (res) {
        setSearchList(filterDetail(res.result || []));
        setLoading(false);
      }).catch(function () {
        setLoading(false);
      });
    }
  }, [search, dataSource, filterDetail]);
  var fetchMoreData = (0, _react.useCallback)(function (categoryCode) {
    return new Promise(function (resolve) {
      var _extra = {};

      if (legalEntityRef.current) {
        _extra.legalEntityCode = legalEntityRef.current;
      }

      if (typeof fetchTreeDetail === 'function') {
        setLoading(true);
        fetchTreeDetail(_objectSpread({
          referenceDataCode: dataSource,
          categoryCode: categoryCode
        }, _extra)).then(function (res) {
          resolve(res);
          setLoading(false);
        }).catch(function () {
          setLoading(false);
        });
      }
    });
  }, [dataSource, fetchTreeDetail]);
  var fetchTreeData = (0, _react.useCallback)(function () {
    var _extra = {};

    if (legalEntityRef.current) {
      _extra.legalEntityCode = legalEntityRef.current;
    }

    if (typeof fetchTree === 'function') {
      setLoading(true);
      fetchTree(_objectSpread({
        referenceDataCode: dataSource
      }, _extra)).then(function (res) {
        setData(res.data);
        setOriginalData(res.data);
        setLoading(false);
      }).catch(function () {
        setLoading(false);
      });
    }
  }, [legalEntityRef, fetchTree, dataSource]);
  var updateTreeData = (0, _react.useCallback)(function (val) {
    var code = val && val.code || null;
    if (legalEntityRef.current === code) return;
    legalEntityRef.current = code;
    fetchTreeData();

    if (legalEntityAuthzs && legalEntityAuthzs.length) {
      if (legalEntityAuthzs.every(function (_ref) {
        var authzCode = _ref.authzCode;
        return authzCode !== code;
      })) {
        handleSelect({});
      }
    }
  }, [fetchTreeData, handleSelect, legalEntityAuthzs]);
  var onSearch = (0, _react.useCallback)(function (value) {
    value = _lodash.default.trim(value);

    if (value) {
      fetchSearchList(value);
    } else {
      setSearchList([]);
    }
  }, [fetchSearchList]);
  var jump = (0, _react.useCallback)(function (crumb, index) {
    var detail = {};

    if (index >= 0) {
      crumbs.length = index + 1;
      detail = crumb;
    } else {
      crumbs.length = 0;
      detail = originalData;
    }

    setData(detail);
    setCrumbs(crumbs);
  }, [crumbs, originalData]);
  var openCategory = (0, _react.useCallback)(function (category) {
    fetchMoreData(category.code).then(function (data) {
      category.details = data.result;
      crumbs.push({
        code: category.code,
        name: category.name,
        details: category.details,
        categories: category.categories
      });
      setData(category);
    });
  }, [fetchMoreData, crumbs]);
  var renderItem = (0, _react.useCallback)(function (item) {
    return _react.default.createElement(_list.default.Item, {
      key: item.code,
      onClick: function onClick() {
        handleSelect(item);
      }
    }, _react.default.createElement("span", {
      className: "item-name"
    }, _react.default.createElement("span", {
      className: "fm fm-paper"
    }), item.name, showBizCode && _react.default.createElement("div", {
      className: "item-code"
    }, item.bizCode)));
  }, [handleSelect, showBizCode]); // 公司抬头变化时 重新请求列表

  (0, _react.useEffect)(function () {
    updateTreeData(legalEntity);
  }, [legalEntity, updateTreeData]);
  (0, _react.useEffect)(function () {
    if (sourceMode === 'DATA_SOURCE') {
      if (privateProps && privateProps.isEntityInAllocation) {
        var _legalEntity = privateProps.form && privateProps.form.getFieldValue('legalEntity');

        legalEntityRef.current = _legalEntity && _legalEntity.code || 'NONE';

        if (setWatch) {
          setWatch('legalEntity', function (value) {
            updateTreeData(value);
          });
        }
      } else {
        legalEntityRef.current = legalEntity ? legalEntity.code : null;
      }
    }

    fetchTreeData();
  }, []);
  return _react.default.createElement("div", {
    className: "".concat(prefix, "-option-input")
  }, _react.default.createElement("div", {
    className: "dropdown ".concat(showDropDownClass)
  }, _react.default.createElement("div", {
    className: "city-picker-display-value-clone"
  }, value && value.name ? _react.default.createElement("div", null, value.name, showBizCode && value.bizCode ? "(".concat(value.bizCode, ")") : '') : _react.default.createElement("div", {
    className: "placeholder"
  }, placeholder)), _react.default.createElement("div", {
    className: "search"
  }, _react.default.createElement(Search, {
    placeholder: transRef.current('searchKeywords'),
    onSearch: onSearch
  })), searchList && searchList.length ? _react.default.createElement(_list.default, {
    dataSource: searchList,
    renderItem: renderItem,
    loading: loading
  }) : _react.default.createElement(_react.default.Fragment, null, _react.default.createElement("div", {
    className: "crumbs"
  }, _react.default.createElement("div", {
    className: "crumb-item",
    onClick: jump
  }, _react.default.createElement("span", {
    className: "crumb-name"
  }, label)), crumbs.map(function (crumb, index) {
    return _react.default.createElement("div", {
      key: index,
      className: "crumb-item",
      onClick: function onClick() {
        return jump(crumb, index);
      }
    }, _react.default.createElement("span", {
      className: "split"
    }, "/"), _react.default.createElement("span", {
      className: "crumb-name"
    }, crumb.name));
  })), _react.default.createElement("div", {
    className: "panel"
  }, data.categories && data.categories.length ? _react.default.createElement("div", {
    className: "category"
  }, data.categories.map(function (category) {
    return _react.default.createElement("div", {
      className: "item",
      key: category.code,
      onClick: function onClick() {
        return openCategory(category);
      }
    }, _react.default.createElement("span", {
      className: "fm fm-folder-o"
    }), category.name);
  })) : null, details.length ? _react.default.createElement("div", {
    className: "detail"
  }, details.map(function (detail) {
    return _react.default.createElement("div", {
      className: "item",
      key: detail.code,
      onClick: function onClick() {
        return handleSelect(detail);
      }
    }, _react.default.createElement("span", {
      className: "fm fm-paper"
    }), detail.name, showBizCode && _react.default.createElement("div", {
      className: "item-code"
    }, detail.bizCode));
  })) : null, (!details || !details.length) && (!data.categories || !data.categories.length) ? _react.default.createElement("div", {
    className: "empty-text"
  }, transRef.current('noData')) : null, _react.default.createElement(_Loader.default, {
    active: loading,
    mask: true
  })))));
}

var clickOutsideConfig = {
  handleClickOutside: function handleClickOutside() {
    return OptionInputList.handleClickOutside;
  }
};

var _default = (0, _reactOnclickoutside.default)(OptionInputList, clickOutsideConfig);

exports.default = _default;