"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = OptionsModal;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _react = _interopRequireWildcard(require("react"));

var _TranslateHook = _interopRequireDefault(require("../hooks/TranslateHook"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var prefix = _utils.default.prefixCls;

function OptionsModal(props) {
  var promise = props.promise,
      _props$wrapWidth = props.wrapWidth,
      wrapWidth = _props$wrapWidth === void 0 ? 520 : _props$wrapWidth,
      _props$dataValueKey = props.dataValueKey,
      dataValueKey = _props$dataValueKey === void 0 ? 'code' : _props$dataValueKey,
      _props$dataLabelKey = props.dataLabelKey,
      dataLabelKey = _props$dataLabelKey === void 0 ? 'label' : _props$dataLabelKey,
      options = props.options,
      title = props.title,
      alertObj = props.alertObj,
      _props$isRadio = props.isRadio,
      isRadio = _props$isRadio === void 0 ? true : _props$isRadio,
      _props$contentMaxHeig = props.contentMaxHeight,
      contentMaxHeight = _props$contentMaxHeig === void 0 ? 250 : _props$contentMaxHeig,
      defaultSelectedKeys = props.defaultSelectedKeys; // 国际化文件

  var translate = (0, _TranslateHook.default)('OptionsModal'); // 当前选中的 option 的 dataValueKey

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      curOptionKey = _useState2[0],
      setCurOptionKey = _useState2[1];

  var handleCancel = (0, _react.useCallback)(function () {
    promise.reject();
  }, [promise]); // 点击选中

  var handleSelect = (0, _react.useCallback)(function (item) {
    if (isRadio) {
      setCurOptionKey([item[dataValueKey]]);
    } else {
      var _curOptionKey = _toConsumableArray(curOptionKey);

      if (_curOptionKey.includes(item[dataValueKey])) {
        _curOptionKey = _curOptionKey.filter(function (key) {
          return key !== item[dataValueKey];
        });
      } else {
        _curOptionKey.push(item[dataValueKey]);
      }

      setCurOptionKey(_curOptionKey);
    }
  }, [curOptionKey, dataValueKey, isRadio]); // 确认选择

  var handleConfirm = (0, _react.useCallback)(function () {
    if (curOptionKey && curOptionKey.length > 0) {
      var _options = options.filter(function (item) {
        return curOptionKey.includes(item[dataValueKey]);
      });

      promise.resolve(isRadio ? _options[0] : _options);
    } else {
      _message2.default.info(translate('noSelect'));
    }
  }, [curOptionKey, dataValueKey, isRadio, options, promise, translate]);
  var transText = (0, _react.useMemo)(function () {
    return {
      cancelText: translate('MkGlobal:cancel'),
      okText: translate('MkGlobal:ok'),
      title: translate('title')
    };
  }, [translate]);
  (0, _react.useEffect)(function () {
    // 判断 单选 or 多选
    var selectedKeys = [];

    if (defaultSelectedKeys && defaultSelectedKeys.length > 0) {
      if (isRadio) {
        selectedKeys = defaultSelectedKeys[0];
      } else {
        selectedKeys = defaultSelectedKeys;
      }
    }

    setCurOptionKey(selectedKeys);
  }, [defaultSelectedKeys, isRadio]);
  return _react.default.createElement(_modal.default, {
    cancelButtonProps: {
      type: 'info'
    },
    cancelText: transText.cancelText,
    className: "".concat(prefix, "-modal-wrap"),
    okText: transText.okText,
    onCancel: handleCancel,
    onOk: handleConfirm,
    title: title || transText.title,
    visible: true,
    width: wrapWidth
  }, alertObj, _react.default.createElement("div", {
    className: "content-wrap",
    style: {
      maxHeight: contentMaxHeight
    }
  }, options && options.length > 0 && options.map(function (option) {
    return _react.default.createElement("div", {
      className: (0, _classnames.default)('option-wrap', {
        'checked': curOptionKey && curOptionKey.length > 0 && curOptionKey.includes(option[dataValueKey])
      }),
      key: option[dataValueKey],
      onClick: function onClick() {
        return handleSelect(option);
      }
    }, option[dataLabelKey], curOptionKey && curOptionKey.length > 0 && curOptionKey.includes(option[dataValueKey]) && _react.default.createElement("div", {
      className: "fm fm-check",
      style: {
        color: '#3296FA'
      }
    }));
  })));
}