"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/col/style/css");

var _col = _interopRequireDefault(require("maycur-antd/lib/col"));

var _react = _interopRequireDefault(require("react"));

var _FormDish = _interopRequireDefault(require("../FormDish"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2019-12-25 19:14:20
 * @LastEditors: RongWei
 * @LastEditTime: 2020-03-23 16:21:49
 */
var cmClzName = _utils.default.prefixCls + '-form-item';

function FormItem(props) {
  var _props$field = props.field,
      property = _props$field.property,
      type = _props$field.type,
      extra = _props$field.extra,
      identifier = _props$field.identifier,
      children = props.children,
      form = props.form,
      isInTable = props.isInTable,
      complexFields = props.complexFields,
      specialFields = props.specialFields;
  var label = property.label,
      _property$webSize = property.webSize,
      webSize = _property$webSize === void 0 ? 0.5 : _property$webSize,
      required = property.required;
  var _label = label;
  var hasSplit = false;
  var labelClz = (0, _classnames.default)("".concat(cmClzName, "-label"), {
    'complex': complexFields.includes(type),
    'required': required
  });

  if (isInTable || specialFields.includes(type)) {
    _label = null;
  }

  if (webSize === 1 && (isInTable || specialFields.includes(type) || complexFields.includes(type))) {
    hasSplit = true;
  }

  var errMsg = form.getFieldError(identifier);
  var Wrap = isInTable ? _react.default.Fragment : _col.default;
  var wrapProps = isInTable ? {} : {
    span: 24 * webSize,
    className: "mk-col ".concat(errMsg ? 'has-err' : '')
  };
  return _react.default.createElement(Wrap, wrapProps, hasSplit ? _react.default.createElement("div", {
    className: "".concat(cmClzName, "-split")
  }) : null, _react.default.createElement("div", {
    className: cmClzName
  }, _label ? _react.default.createElement("div", {
    className: "".concat(cmClzName, "-header")
  }, _react.default.createElement("div", {
    className: labelClz
  }, _label), _react.default.createElement("div", {
    className: "".concat(cmClzName, "-header_extra")
  }, extra)) : null, _react.default.createElement("div", {
    className: "".concat(cmClzName, "-body")
  }, _react.default.createElement("div", null, children, !!errMsg && _react.default.createElement("span", {
    className: "".concat(cmClzName, "-error")
  }, errMsg)))));
}

var FormFood = (0, _FormDish.default)(FormItem);
var _default = FormFood;
exports.default = _default;